//
//  User.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 8/30/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "User.h"
#import "Utils.h"
#import "UserSettings.h"

@implementation User

- (id)init {
    self = [super init];
    if(self) {
        
    }
    return self;
}

+ (NSData *)dataFromObject:(id)obj {
    if(obj != nil) {
        NSError *error;
        return [NSJSONSerialization dataWithJSONObject:obj options:0 error:&error];
    }
    else {
        return nil;
    }
}

+ (id)objectFromData:(NSData *)data {
    if(data != nil) {
        NSError *error;
        return [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
    }
    else {
        return nil;
    }
}

+ (NSData *)dataFromString:(NSString *)obj {
    return [obj dataUsingEncoding:NSUTF8StringEncoding];
}

+ (NSString *)stringFromData:(NSData *)data {
    return [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
}

+ (NSData *)dataFromBoolean:(BOOL)obj {
    return [NSData dataWithBytes:&obj length:sizeof(BOOL)];
}

+ (BOOL)booleanFromData:(NSData *)data {
    return *(BOOL *)data.bytes;
}

+ (NSData *)dataFromInt:(int)obj {
    return [NSData dataWithBytes:&obj length:sizeof(int)];
}

+ (int)intFromData:(NSData *)data {
    return *(int *)data.bytes;
}

+ (NSData *)dataFromDate:(NSDate *)obj {
    if(obj != nil) {
        NSTimeInterval date = obj.timeIntervalSince1970;
        return [NSData dataWithBytes:&date length:sizeof(NSTimeInterval)];
    }
    else {
        return nil;
    }
}

+ (NSDate *)dateFromData:(NSData *)data {
    if(data != nil) {
        return [NSDate dateWithTimeIntervalSince1970:*(NSTimeInterval *)data.bytes];
    }
    else {
        return nil;
    }
}

- (void)save {
    NSFetchRequest *request = [NSFetchRequest fetchRequestWithEntityName:@"UserSettings"];
    NSManagedObjectContext *context = [Utils getContext];
    NSError *error;
    NSArray *res = [context executeFetchRequest:request error:&error];
    UserSettings *zip = nil;
    UserSettings *state = nil;
    UserSettings *city = nil;
    UserSettings *date = nil;
    UserSettings *make = nil;
    UserSettings *model = nil;
    UserSettings *condition = nil;
    UserSettings *method = nil;
    UserSettings *name = nil;
    UserSettings *phone = nil;
    UserSettings *email = nil;
    UserSettings *company = nil;
    UserSettings *distance = nil;
    UserSettings *move = nil;
    UserSettings *launchcount = nil;
    UserSettings *launchdate = nil;
    UserSettings *rated = nil;
    for(UserSettings *setting in res) {
        if([setting.name isEqualToString:@"zip"]) {
            zip = setting;
        }
        else if([setting.name isEqualToString:@"state"]) {
            state = setting;
        }
        else if([setting.name isEqualToString:@"city"]) {
            city = setting;
        }
        else if([setting.name isEqualToString:@"date"]) {
            date = setting;
        }
        else if([setting.name isEqualToString:@"make"]) {
            make = setting;
        }
        else if([setting.name isEqualToString:@"model"]) {
            model = setting;
        }
        else if([setting.name isEqualToString:@"condition"]) {
            condition = setting;
        }
        else if([setting.name isEqualToString:@"method"]) {
            method = setting;
        }
        else if([setting.name isEqualToString:@"name"]) {
            name = setting;
        }
        else if([setting.name isEqualToString:@"phone"]) {
            phone = setting;
        }
        else if([setting.name isEqualToString:@"email"]) {
            email = setting;
        }
        else if([setting.name isEqualToString:@"distance"]) {
            distance = setting;
        }
        else if([setting.name isEqualToString:@"move"]) {
            move = setting;
        }
        else if([setting.name isEqualToString:@"launchcount"]) {
            launchcount = setting;
        }
        else if([setting.name isEqualToString:@"launchdate"]) {
            launchdate = setting;
        }
        else if([setting.name isEqualToString:@"rated"]) {
            rated = setting;
        }
    }
    if(zip == nil) {
        zip = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        zip.name = @"zip";
    }
    zip.value = [User dataFromObject:self.zip];
    if(state == nil) {
        state = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        state.name = @"state";
    }
    state.value = [User dataFromObject:self.state];
    if(city == nil) {
        city = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        city.name = @"city";
    }
    city.value = [User dataFromObject:self.city];
    if(date == nil) {
        date = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        date.name = @"date";
    }
    date.value = [User dataFromObject:self.date];
    if(make == nil) {
        make = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        make.name = @"make";
    }
    make.value = [User dataFromObject:self.make];
    if(model == nil) {
        model = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        model.name = @"model";
    }
    model.value = [User dataFromObject:self.model];
    if(condition == nil) {
        condition = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        condition.name = @"condition";
    }
    condition.value = [User dataFromObject:self.condition];
    if(method == nil) {
        method = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        method.name = @"method";
    }
    method.value = [User dataFromObject:self.method];
    if(name == nil) {
        name = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        name.name = @"name";
    }
    name.value = [User dataFromString:self.name];
    if(phone == nil) {
        phone = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        phone.name = @"phone";
    }
    phone.value = [User dataFromString:self.phone];
    if(email == nil) {
        email = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        email.name = @"email";
    }
    email.value = [User dataFromString:self.email];
    if(company == nil) {
        company = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        company.name = @"company";
    }
    company.value = [User dataFromString:self.company];
    if(distance == nil) {
        distance = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        distance.name = @"distance";
    }
    distance.value = [User dataFromString:self.distance];
    if(move == nil) {
        move = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        move.name = @"move";
    }
    move.value = [User dataFromBoolean:self.move];
    if(launchcount == nil) {
        launchcount = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        launchcount.name = @"launchcount";
    }
    launchcount.value = [User dataFromInt:self.launchcount];
    if(launchdate == nil) {
        launchdate = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        launchdate.name = @"launchdate";
    }
    launchdate.value = [User dataFromDate:self.launchdate];
    if(rated == nil) {
        rated = (UserSettings *)[NSEntityDescription insertNewObjectForEntityForName:@"UserSettings" inManagedObjectContext:context];
        rated.name = @"rated";
    }
    rated.value = [User dataFromBoolean:self.rated];
    [Utils saveContext];
    
}

+ (instancetype)getCurrent {
    NSFetchRequest *request = [NSFetchRequest fetchRequestWithEntityName:@"UserSettings"];
    NSManagedObjectContext *context = [Utils getContext];
    NSError *error;
    NSArray *res = [context executeFetchRequest:request error:&error];
    if(res.count > 0) {
        User *user = [[User alloc] init];
        for(UserSettings *setting in res) {
            if([setting.name isEqualToString:@"zip"]) {
                user.zip = (NSDictionary<NSString *, NSString *> *)[User objectFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"state"]) {
                user.state = (NSDictionary<NSString *, NSString *> *)[User objectFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"city"]) {
                user.city = (NSDictionary<NSString *, NSString *> *)[User objectFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"date"]) {
                user.date = (NSDictionary<NSString *, NSNumber *> *)[User objectFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"make"]) {
                user.make = (NSDictionary<NSString *, NSString *> *)[User objectFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"model"]) {
                user.model = (NSDictionary<NSString *, NSString *> *)[User objectFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"condition"]) {
                user.condition = (NSDictionary<NSString *, NSString *> *)[User objectFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"method"]) {
                user.method = (NSDictionary<NSString *, NSString *> *)[User objectFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"name"]) {
                user.name = [User stringFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"phone"]) {
                user.phone = [User stringFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"email"]) {
                user.email = [User stringFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"company"]) {
                user.company = [User stringFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"distance"]) {
                user.distance = [User stringFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"move"]) {
                user.move = [User booleanFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"launchcount"]) {
                user.launchcount = [User intFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"launchdate"]) {
                user.launchdate = [User dateFromData:setting.value];
            }
            else if([setting.name isEqualToString:@"rated"]) {
                user.rated = [User booleanFromData:setting.value];
            }
        }
        return user;
    }
    else {
        return nil;
    }
}

@end
