//
//  HomeViewController.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 6/25/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "HomeViewController.h"
#import "HomeTableViewCell.h"
#import "HomeButtonsTableViewCell.h"
#import "MoveViewController.h"
#import "User.h"
#import "Utils.h"
#import "URLRequests.h"

@interface HomeViewController ()

@property (weak, nonatomic) IBOutlet UITableView *tableView;

@property (assign, nonatomic) BOOL started;

@end

@implementation HomeViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    [URLRequests getTexts];
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    User *user = [User getCurrent];
    if(user == nil || !user.move) {
        [self performSegueWithIdentifier:@"editmove" sender:self];
    }
    else {
        if(!self.started) {
            if(!user.rated && (user.launchcount == 2 || (user.launchdate != nil && [NSDate date].timeIntervalSince1970 - user.launchdate.timeIntervalSince1970 > 72 * 60 * 60))) {
                [self performSegueWithIdentifier:@"rate" sender:self];
            }
            else {
                user.launchcount += 1;
                user.launchdate = [NSDate date];
            }
            [user save];
        }
        self.started = YES;
        [self.tableView reloadData];
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
    if([segue.destinationViewController isKindOfClass:[MoveViewController class]]) {
        if(sender == self) {
            ((MoveViewController *)segue.destinationViewController).inventory = YES;
        }
    }
}

#pragma mark - UITableViewDataSource

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 4;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    if(indexPath.row == 0) {
        HomeButtonsTableViewCell *cell = (HomeButtonsTableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"buttons"];
        return cell;
    }
    else {
        HomeTableViewCell *cell = (HomeTableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"cell"];
        NSString *text;
        switch(indexPath.row) {
            case 1:
                text = [Utils getText:@"home_screen-button_preferences"];
                if(text == nil) {
                    text = @"Shipping preferences";
                }
                [cell setImage:@"dr_pref" text:text];
                break;
//            case 2:
//                text = [Utils getText:@"home_screen-button_email_info"];
//                if(text == nil) {
//                    text = @"Email my shipping information";
//                }
//                [cell setImage:@"dr_mail" text:text];
//                break;
//            case 2:
//                text = [Utils getText:@"home_screen-button_reset"];
//                if(text == nil) {
//                    text = @"Start a fresh shipping";
//                }
//                [cell setImage:@"dr_newmove" text:text];
//                break;
            case 2:
                text = [Utils getText:@"home_screen-button_advertise"];
                if(text == nil) {
                    text = @"Advertise";
                }
                [cell setImage:@"dr_advertise" text:text];
                break;
            case 3:
                text = [Utils getText:@"home_screen-button_about"];
                if(text == nil) {
                    text = @"About";
                }
                [cell setImage:@"dr_about" text:text];
                break;
        }
        return cell;
    }
}

#pragma mark - UITableViewDelegate

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    if(indexPath.row == 0) {
        if(self.view.frame.size.height >= 438) {
            return self.view.frame.size.height - 22;
        }
        else {
            return 438;
        }
    }
    else {
        return 44;
    }
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    switch(indexPath.row) {
        case 1:
            [self performSegueWithIdentifier:@"editmove" sender:[tableView cellForRowAtIndexPath:indexPath]];
            break;
//        case 2:
//            [self performSegueWithIdentifier:@"email" sender:[tableView cellForRowAtIndexPath:indexPath]];
//            break;
//        case 2:
//            [self performSegueWithIdentifier:@"freshmove" sender:[tableView cellForRowAtIndexPath:indexPath]];
//            break;
        case 2:
            [self performSegueWithIdentifier:@"advertise" sender:[tableView cellForRowAtIndexPath:indexPath]];
            break;
        case 3:
            [self performSegueWithIdentifier:@"about" sender:[tableView cellForRowAtIndexPath:indexPath]];
            break;
    }
    [tableView deselectRowAtIndexPath:indexPath animated:NO];
}

@end
