//
//  MoveViewController.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 8/9/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "MoveViewController.h"
#import "StatesViewController.h"
//#import "MoveSizeViewController.h"
#import "CalendarViewController.h"
#import "MoveRideViewController.h"
#import "MoveUserViewController.h"
#import "User.h"
#import "Utils.h"
#import "URLRequests.h"

@interface MoveViewController ()

@property (weak, nonatomic) IBOutlet UIImageView *imageBackground;

@property (weak, nonatomic) IBOutlet UIScrollView *scrollView;
@property (weak, nonatomic) IBOutlet UIView *viewContainer;
@property (weak, nonatomic) IBOutlet UIView *viewTable;

@property (weak, nonatomic) IBOutlet UILabel *labelTitle;
@property (weak, nonatomic) IBOutlet UILabel *labelSubTitle;
@property (weak, nonatomic) IBOutlet UIButton *buttonClose;

@property (weak, nonatomic) IBOutlet UILabel *labelZIPHeader;
@property (weak, nonatomic) IBOutlet UILabel *labelZIPError;
@property (weak, nonatomic) IBOutlet UITextField *textZIP;
@property (weak, nonatomic) IBOutlet UILabel *labelZIP;

@property (weak, nonatomic) IBOutlet UILabel *labelStateHeader;
@property (weak, nonatomic) IBOutlet UILabel *labelStateError;
@property (weak, nonatomic) IBOutlet UIButton *buttonState;

@property (weak, nonatomic) IBOutlet UILabel *labelCityHeader;
@property (weak, nonatomic) IBOutlet UILabel *labelCityError;
@property (weak, nonatomic) IBOutlet UITextField *textCity;

@property (weak, nonatomic) IBOutlet UILabel *labelDateHeader;
@property (weak, nonatomic) IBOutlet UILabel *labelDateError;
@property (weak, nonatomic) IBOutlet UIButton *buttonDate;

@property (weak, nonatomic) IBOutlet UITableView *tableCities;

@property (weak, nonatomic) IBOutlet UIButton *buttonOK;

@property (weak, nonatomic) IBOutlet UIView *viewPager;

@property (strong, nonatomic) NSDictionary<NSString *, NSString *> *zip;
@property (strong, nonatomic) NSDictionary<NSString *, NSString *> *state;
@property (strong, nonatomic) NSDictionary<NSString *, NSString *> *city;
@property (strong, nonatomic) NSDictionary<NSString *, NSString *> *size;
@property (strong, nonatomic) NSDictionary<NSString *, NSNumber *> *date;
@property (strong, nonatomic) NSMutableArray<NSDictionary *> *stateCities;
@property (strong, nonatomic) NSArray<NSDictionary *> *cities;

@property (strong, nonatomic) User *user;

@property (strong, nonatomic) NSArray<NSDictionary *> *makes;

@property (assign, nonatomic) CGRect rect;

- (IBAction)onBack:(id)sender;

@end

@implementation MoveViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    if(self.exit) {
        self.imageBackground.hidden = YES;
    }
    self.viewTable.layer.cornerRadius = 5;
    self.tableCities.layer.cornerRadius = 5;
    self.tableCities.layer.borderColor = [UIColor lightGrayColor].CGColor;
    self.tableCities.layer.borderWidth = 1;
    [Utils setText:self.labelTitle text:@"setupform-heading"];
    [Utils setText:self.labelSubTitle text:@"setupform-description_text"];
    [Utils setText:self.labelZIPHeader text:@"setupform-from_zip"];
    [Utils setText:self.textZIP text:@"setupform-from_zip"];
    [Utils setText:self.labelStateHeader text:@"setupform-to_state"];
    [Utils setText:self.buttonState text:@"setupform-to_state"];
    [Utils setText:self.labelCityHeader text:@"setupform-to_city"];
    [Utils setText:self.textCity text:@"setupform-to_city"];
    [Utils setText:self.labelDateHeader text:@"setupform-date"];
    [Utils setText:self.buttonDate text:@"setupform-date"];
    if(!self.exit) {
        [Utils setText:self.buttonOK text:@"setupform-button_submit"];
    }
    else {
        [self.buttonOK setTitle:@"Save changes" forState:UIControlStateNormal];
        self.viewPager.hidden = YES;
        NSLayoutConstraint *constraintHeight = nil;
        NSLayoutConstraint *constraintBottom = nil;
        for(NSLayoutConstraint *constraint in self.viewContainer.constraints) {
            if(constraint.firstAttribute == NSLayoutAttributeHeight) {
                constraintHeight = constraint;
            }
            else if(constraint.secondAttribute == NSLayoutAttributeBottom && constraint.secondItem == self.viewTable) {
                constraintBottom = constraint;
            }
        }
        constraintHeight.constant -= constraintBottom.constant - 10;
        constraintBottom.constant = 10;
    }
    self.user = [User getCurrent];
    if(self.user != nil) {
        if(self.user.move) {
            self.zip = self.user.zip;
            self.textZIP.text = (NSString *)[self.zip objectForKey:@"zip"];
            [self setZIP];
            [self showLabel:self.labelZIPHeader control:self.textZIP animated:NO];
            self.state = self.user.state;
            [self setState];
            self.city = self.user.city;
            self.textCity.text = (NSString *)[self.city objectForKey:@"name"];
            [self showLabel:self.labelCityHeader control:self.textCity animated:NO];
            self.date = self.user.date;
            [self setDate];
        }
    }
    else {
        self.user = [[User alloc] init];
    }
    self.buttonClose.hidden = !self.user.move;
    self.rect = CGRectZero;
    [URLRequests getMakes:^(NSArray *makes) {
        self.makes = makes;
    }];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onShowKeyboard:) name:UIKeyboardWillShowNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onHideKeyboard:) name:UIKeyboardWillHideNotification object:nil];
}

- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIKeyboardWillShowNotification object:nil];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIKeyboardWillHideNotification object:nil];
}

- (void)setConstraints:(int)height duration:(float)duration {
    NSLayoutConstraint *constraintTop = nil;
    NSLayoutConstraint *constraintBottom = nil;
    NSLayoutConstraint *constraintHeight = nil;
    for(NSLayoutConstraint *constraint in self.scrollView.constraints) {
        if(constraint.firstAttribute == NSLayoutAttributeTop && constraint.firstItem == self.viewContainer) {
            constraintTop = constraint;
        }
        else if(constraint.secondAttribute == NSLayoutAttributeBottom && constraint.secondItem == self.viewContainer) {
            constraintBottom = constraint;
        }
    }
    for(NSLayoutConstraint *constraint in self.viewContainer.constraints) {
        if(constraint.firstAttribute == NSLayoutAttributeHeight) {
            constraintHeight = constraint;
        }
    }
    CGFloat top;
    CGFloat bottom;
    if(self.scrollView.frame.size.height - height - constraintHeight.constant - [self.topLayoutGuide length] > 0) {
        top = (self.scrollView.frame.size.height - height - constraintHeight.constant - [self.topLayoutGuide length]) / 2 + [self.topLayoutGuide length];
        bottom = self.scrollView.frame.size.height - constraintHeight.constant - top;
    }
    else {
        top = [self.topLayoutGuide length];
        bottom = height;
    }
    if(duration > 0) {
        [self.scrollView layoutIfNeeded];
        [UIView animateWithDuration:duration animations:^{
            constraintTop.constant = top;
            constraintBottom.constant = bottom;
            [self.scrollView layoutIfNeeded];
        }];
    }
    else {
        constraintTop.constant = top;
        constraintBottom.constant = bottom;
    }
}

- (void)viewDidLayoutSubviews {
    [super viewDidLayoutSubviews];
    if(!CGRectEqualToRect(self.rect, self.view.frame)) {
        [self setConstraints:0 duration:0];
        self.rect = self.view.frame;
    }
}

- (void)onShowKeyboard:(NSNotification *)notification {
    CGRect rect = ((NSValue *)[notification.userInfo objectForKey:UIKeyboardFrameEndUserInfoKey]).CGRectValue;
    double duration = ((NSNumber *)[notification.userInfo objectForKey:UIKeyboardAnimationDurationUserInfoKey]).doubleValue;
    [self setConstraints:rect.size.height duration:duration];
}

- (void)onHideKeyboard:(NSNotification *)notification {
    double duration = ((NSNumber *)[notification.userInfo objectForKey:UIKeyboardAnimationDurationUserInfoKey]).doubleValue;
    [self setConstraints:0 duration:duration];
}

#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
    if([segue.destinationViewController isKindOfClass:[StatesViewController class]]) {
        ((StatesViewController *)segue.destinationViewController).state = self.state;
        ((StatesViewController *)segue.destinationViewController).close = ^(NSDictionary *state) {
            if(self.state == nil || [(NSNumber *)[self.state objectForKey:@"id"] compare:(NSNumber *)[state objectForKey:@"id"]] != NSOrderedSame) {
                self.city = nil;
                self.textCity.text = @"";
                [self hideLabel:self.labelCityHeader control:self.textCity animated:YES];
            }
            self.state = state;
            [self setState];
            [self check:self.state label:self.labelStateError];
        };
    }
    else if([segue.destinationViewController isKindOfClass:[CalendarViewController class]]) {
        ((CalendarViewController *)segue.destinationViewController).date = self.date;
        ((CalendarViewController *)segue.destinationViewController).close = ^(NSDictionary *date) {
            self.date = date;
            [self setDate];
            [self check:self.date label:self.labelDateError];
        };
    }
    else if([segue.destinationViewController isKindOfClass:[MoveRideViewController class]]) {
        ((MoveRideViewController *)segue.destinationViewController).makes = self.makes;
    }
    else if([segue.destinationViewController isKindOfClass:[MoveUserViewController class]]) {

    }
    if([self.textZIP isFirstResponder]) {
        [self.textZIP resignFirstResponder];
    }
    if([self.textCity isFirstResponder]) {
        [self.textCity resignFirstResponder];
    }
}


- (IBAction)onBack:(id)sender {
    if([self.textZIP isFirstResponder]) {
        [self.textZIP resignFirstResponder];
    }
    if([self.textCity isFirstResponder]) {
        [self.textCity resignFirstResponder];
    }
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

- (void)showLabel:(UILabel *)label control:(UIControl *)control animated:(BOOL)animated {
    if(animated) {
        CATransition *transition = [[CATransition alloc] init];
        transition.type = kCATransitionFade;
        transition.subtype = kCATransitionFromBottom;
        transition.duration = 0.25;
        [label.layer addAnimation:transition forKey:kCATransition];
    }
    label.hidden = NO;
    if([control isKindOfClass:[UIButton class]]) {
        [(UIButton *)control setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    }
    for(NSLayoutConstraint *constraint in control.superview.constraints) {
        if(constraint.firstAttribute == NSLayoutAttributeTop && constraint.firstItem == control) {
            constraint.constant = 30;
        }
    }
}

- (void)hideLabel:(UILabel *)label control:(UIControl *)control animated:(BOOL)animated {
    if(animated) {
        CATransition *transition = [[CATransition alloc] init];
        transition.type = kCATransitionFade;
        transition.subtype = kCATransitionFromBottom;
        transition.duration = 0.25;
        [label.layer addAnimation:transition forKey:kCATransition];
    }
    label.hidden = YES;
    if([control isKindOfClass:[UIButton class]]) {
        [(UIButton *)control setTitleColor:[UIColor colorWithWhite:0.785f alpha:1] forState:UIControlStateNormal];
    }
    for(NSLayoutConstraint *constraint in control.superview.constraints) {
        if(constraint.firstAttribute == NSLayoutAttributeTop && constraint.firstItem == control) {
            constraint.constant = 5;
        }
    }
}

- (void)getZIP:(NSString *)zip {
    if(zip.length == 5) {
        NSString *path = [[NSBundle mainBundle] pathForResource:[zip substringToIndex:1] ofType:@"json"];
        NSData *data = [NSData dataWithContentsOfFile:path];
        if(data != nil) {
            NSError *jsonerror;
            NSDictionary *json = (NSDictionary *)[NSJSONSerialization JSONObjectWithData:data options:0 error:&jsonerror];
            if(json != nil) {
                json = (NSDictionary *)[json objectForKey:zip];
                if(json != nil) {
                    self.zip = @{@"zip": zip, @"state": (NSString *)[json objectForKey:@"pc_admin1_code"], @"city": (NSString *)[json objectForKey:@"pc_place_name"]};
                }
                else {
                    self.zip = nil;
                }
            }
            else {
                self.zip = nil;
            }
        }
        else {
            self.zip = nil;
        }
    }
    else {
        self.zip = nil;
    }
    CATransition *transition = [[CATransition alloc] init];
    transition.type = kCATransitionFade;
    transition.duration = 0.25;
    [self.labelZIP.layer addAnimation:transition forKey:kCATransition];
    [self setZIP];
    if(zip.length == 5) {
        [self check:self.zip label:self.labelZIPError];
    }
    else {
        [self check:@{@"zip": zip} label:self.labelZIPError];
    }
}

- (void)setZIP {
    if(self.zip != nil) {
        self.labelZIP.text = [NSString stringWithFormat:@"%@, %@", (NSString *)[self.zip objectForKey:@"city"], (NSString *)[self.zip objectForKey:@"state"]];
    }
    else {
        self.labelZIP.text = @"";
    }
}

- (void)getCities:(NSString *)city {
    if(self.stateCities != nil && city.length > 2) {
        self.cities = [self.stateCities filteredArrayUsingPredicate:[NSPredicate predicateWithFormat:@"name beginswith[c] %@", city]];
    }
    else {
        self.cities = nil;
    }
    for(NSLayoutConstraint *constraint in self.tableCities.constraints) {
        if(constraint.firstAttribute == NSLayoutAttributeHeight) {
            NSUInteger count;
            if(self.cities != nil) {
                if(self.cities.count > 3) {
                    count = 3;
                }
                else {
                    count = self.cities.count;
                }
            }
            else {
                count = 0;
            }
            constraint.constant = count * 30 + 10;
            break;
        }
    }
    [self.tableCities reloadData];
    if(self.cities != nil) {
        [self.tableCities scrollToRowAtIndexPath:[NSIndexPath indexPathForRow:0 inSection:0] atScrollPosition:UITableViewScrollPositionTop animated:NO];
        self.tableCities.hidden = NO;
    }
    else {
        self.tableCities.hidden = YES;
    }
}

- (void)setState {
    NSString *path = [[NSBundle mainBundle] pathForResource:[self.state objectForKey:@"abr"].lowercaseString ofType:@"json"];
    NSData *data = [NSData dataWithContentsOfFile:path];
    if(data != nil) {
        NSError *jsonerror;
        NSDictionary<NSString *, NSDictionary *> *json = (NSDictionary<NSString *, NSDictionary *> *)[NSJSONSerialization JSONObjectWithData:data options:0 error:&jsonerror];
        if(json != nil) {
            self.stateCities = [[NSMutableArray<NSDictionary *> alloc] init];
            for(NSString *key in json.allKeys) {
                [self.stateCities addObject:@{@"name": key, @"zips_cnt": [[json objectForKey:key] objectForKey:@"zips_cnt"]}];
            }
            [self.stateCities sortUsingComparator:^NSComparisonResult(id obj1, id obj2) {
                NSNumber *zips_cnt1 = (NSNumber *)(NSDictionary *)[obj1 objectForKey:@"zips_cnt"];
                NSNumber *zips_cnt2 = (NSNumber *)(NSDictionary *)[obj2 objectForKey:@"zips_cnt"];
                return [zips_cnt2 compare:zips_cnt1];
            }];
            [self.buttonState setTitle:[self.state objectForKey:@"name"] forState:UIControlStateNormal];
            [self showLabel:self.labelStateHeader control:self.buttonState animated:NO];
        }
        else {
            self.stateCities = nil;
        }
    }
    else {
        self.stateCities = nil;
    }
}

- (void)setDate {
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    formatter.locale = [NSLocale localeWithLocaleIdentifier:@"en_US"];
    formatter.dateStyle = NSDateFormatterMediumStyle;
    formatter.timeStyle = NSDateFormatterNoStyle;
    NSCalendar *calendar = [NSCalendar calendarWithIdentifier:NSCalendarIdentifierGregorian];
    NSDateComponents *components = [[NSDateComponents alloc] init];
    components.year = ((NSNumber *)[self.date objectForKey:@"year"]).intValue;
    components.month = ((NSNumber *)[self.date objectForKey:@"month"]).intValue;
    components.day = ((NSNumber *)[self.date objectForKey:@"day"]).intValue;
    components.timeZone = calendar.timeZone;
    [self.buttonDate setTitle:[formatter stringFromDate:[calendar dateFromComponents:components]] forState:UIControlStateNormal];
    [self showLabel:self.labelDateHeader control:self.buttonDate animated:NO];
}

- (BOOL)check:(NSDictionary *)obj label:(UILabel *)label {
    CATransition *transition = [[CATransition alloc] init];
    transition.type = kCATransitionFade;
    transition.subtype = kCATransitionFromBottom;
    transition.duration = 0.25;
    [label.layer addAnimation:transition forKey:kCATransition];
    if(obj != nil) {
        label.hidden = YES;
        return YES;
    }
    else {
        label.hidden = NO;
        return NO;
    }
}

- (IBAction)onOK:(id)sender {
    BOOL checkZIP = [self check:self.zip label:self.labelZIPError];
    BOOL checkState = [self check:self.state label:self.labelStateError];
    BOOL checkCity = [self check:self.city label:self.labelCityError];
    BOOL checkDate = [self check:self.date label:self.labelDateError];
    if(checkZIP && checkState && checkCity && checkDate) {
        self.user.zip = self.zip;
        self.user.state = self.state;
        self.user.city = self.city;
        self.user.date = self.date;
//        if(self.inventory) {
//            self.user.move = YES;
//            [Utils initRooms:((NSNumber *)[self.user.size objectForKey:@"id"]).intValue];
//        }
        [self.user save];
        if([self.textZIP isFirstResponder]) {
            [self.textZIP resignFirstResponder];
        }
        if([self.textCity isFirstResponder]) {
            [self.textCity resignFirstResponder];
        }
        if(self.exit) {
            [self dismissViewControllerAnimated:YES completion:^{
                if(self.close != nil) {
                    self.close();
                }
            }];
        }
        else {
            [self performSegueWithIdentifier:@"ride" sender:self];
        }
    }
}

#pragma mark - UITextFieldDelegate

- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
    NSString *text = [textField.text stringByReplacingCharactersInRange:range withString:string];
    if(textField == self.textZIP) {
        if(![text isEqualToString:@""]) {
            [self showLabel:self.labelZIPHeader control:self.textZIP animated:YES];
        }
        else {
            [self hideLabel:self.labelZIPHeader control:self.textZIP animated:YES];
        }
        if(text.length <= 5) {
            [self getZIP:text];
            return YES;
        }
        else {
            return NO;
        }
    }
    else if(textField == self.textCity) {
        if(![text isEqualToString:@""]) {
            [self showLabel:self.labelCityHeader control:self.textCity animated:YES];
        }
        else {
            [self hideLabel:self.labelCityHeader control:self.textCity animated:YES];
        }
        [self getCities:text];
        [self check:@{@"name": text} label:self.labelCityError];
        return YES;
    }
    else {
        return YES;
    }
}

- (void)textFieldDidBeginEditing:(UITextField *)textField {
    if(textField == self.textZIP) {
    }
    else if(textField == self.textCity) {
    }
}

- (void)textFieldDidEndEditing:(UITextField *)textField {
    if(textField == self.textZIP) {
    }
    else if(textField == self.textCity) {
        if(![self.textCity.text isEqualToString:@""]) {
            self.city = nil;
            if(self.stateCities != nil) {
                for(NSDictionary *city in self.stateCities) {
                    if([(NSString *)[city objectForKey:@"name"] caseInsensitiveCompare:self.textCity.text] == NSOrderedSame) {
                        self.city = city;
                        break;
                    }
                }
            }
            if(self.city == nil) {
                self.city = @{@"name": self.textCity.text};
            }
        }
        else {
            self.city = nil;
        }
        self.cities = nil;
        [self.tableCities reloadData];
        self.tableCities.hidden = YES;
    }
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
    [textField resignFirstResponder];
    return YES;
}

#pragma mark - UITableViewDataSource

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    if(self.cities != nil) {
        return self.cities.count + 2;
    }
    else {
        return 0;
    }
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    if(indexPath.row > 0 && indexPath.row < self.cities.count + 1) {
        UITableViewCell *cell = (UITableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"cell"];
        NSDictionary<NSString *, NSString *> *city = [self.cities objectAtIndex:indexPath.row - 1];
        cell.textLabel.text = [city objectForKey:@"name"];
        return cell;
    }
    else {
        UITableViewCell *cell = (UITableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"empty"];
        return cell;
    }
}

#pragma mark - UITableViewDelegate

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    if(indexPath.row > 0 && indexPath.row < self.cities.count + 1) {
        return 30;
    }
    else {
        return 5;
    }
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    if(indexPath.row > 0 && indexPath.row < self.cities.count + 1) {
        self.city = [self.cities objectAtIndex:indexPath.row - 1];
        self.textCity.text = [self.city objectForKey:@"name"];
        self.cities = nil;
        [self.tableCities reloadData];
        self.tableCities.hidden = YES;
        if([self.textCity isFirstResponder]) {
            [self.textCity resignFirstResponder];
        }
        
    }
}

@end
