//
//  MoverContactViewController.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 8/31/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "MoverContactViewController.h"
#import "MoverSendMessageViewController.h"

@interface MoverContactViewController ()

@property (weak, nonatomic) IBOutlet UIView *viewContainer;
@property (weak, nonatomic) IBOutlet UILabel *labelTitle;
@property (weak, nonatomic) IBOutlet UIButton *buttonContact;
@property (weak, nonatomic) IBOutlet UIButton *buttonContactThisMover;

- (IBAction)onBack:(id)sender;
- (IBAction)onContact:(id)sender;
- (IBAction)onContactThisMover:(id)sender;

@end

@implementation MoverContactViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.viewContainer.layer.cornerRadius = 5;
    self.labelTitle.text = self.textTitle;
    [self.buttonContact setImage:[UIImage imageNamed:[self.contact objectForKey:@"image"]] forState:UIControlStateNormal];
    [self.buttonContact setTitle:[self.contact objectForKey:@"contact"] forState:UIControlStateNormal];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
    if([segue.destinationViewController isKindOfClass:[MoverSendMessageViewController class]]) {
        ((MoverSendMessageViewController *)segue.destinationViewController).mover = self.mover;
    }
}


- (IBAction)onBack:(id)sender {
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

- (IBAction)onContact:(id)sender {
    NSString *type = [self.contact objectForKey:@"type"];
    NSString *contact = [self.contact objectForKey:@"contact"];
    NSString *url = nil;
    if([type isEqualToString:@"phone"]) {
        url = [NSString stringWithFormat:@"tel://%@", [[[[contact stringByReplacingOccurrencesOfString:@" " withString:@""] stringByReplacingOccurrencesOfString:@"-" withString:@""] stringByReplacingOccurrencesOfString:@"(" withString:@""] stringByReplacingOccurrencesOfString:@")" withString:@""]];
    }
    else if([type isEqualToString:@"email"]) {
        url = [NSString stringWithFormat:@"mailto:?to=%@", contact];
    }
    else if([type isEqualToString:@"website"]) {
        url = contact;
    }
    if(url != nil) {
        [[UIApplication sharedApplication] openURL:[NSURL URLWithString:url]];
    }
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

- (IBAction)onContactThisMover:(id)sender {

}

@end
