//
//  MoverRatingTableViewCell.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 7/29/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "MoverRatingTableViewCell.h"

@interface MoverRatingTableViewCell ()

@property (weak, nonatomic) IBOutlet UILabel *labelType;
@property (weak, nonatomic) IBOutlet UIView *viewReviews;
@property (weak, nonatomic) IBOutlet UILabel *labelReviews;

@property (weak, nonatomic) NSLayoutConstraint *constraintReviews;

@end

@implementation MoverRatingTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
    for(NSLayoutConstraint *constraint in self.contentView.constraints) {
        if(constraint.secondItem == self.viewReviews && constraint.secondAttribute == NSLayoutAttributeTrailing) {
            self.constraintReviews = constraint;
            break;
        }
    }
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
    
    // Configure the view for the selected state
}

- (void)setData:(NSDictionary *)data reviews:(NSUInteger)reviews size:(int)size {
    self.labelType.text = (NSString *)[data objectForKey:@"type"];
    if(reviews > 0) {
        self.constraintReviews.constant = size - 100 - ((NSNumber *)[data objectForKey:@"reviews"]).intValue * (size - 150) / reviews;
    }
    else {
        self.constraintReviews.constant = size - 100;
    }
    self.labelReviews.text = ((NSNumber *)[data objectForKey:@"reviews"]).stringValue;
}

@end
