//
//  MoverReviewTableViewCell.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 7/4/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "MoverReviewTableViewCell.h"

@interface MoverReviewTableViewCell ()

@property (weak, nonatomic) IBOutlet UIImageView *imageReview;
@property (weak, nonatomic) IBOutlet UILabel *labelCustomer;
@property (weak, nonatomic) IBOutlet UIImageView *imageRating;
@property (weak, nonatomic) IBOutlet UILabel *labelDate;
@property (weak, nonatomic) IBOutlet UILabel *labelText;

@end

@implementation MoverReviewTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
    self.imageReview.layer.cornerRadius = 35;
    self.imageReview.layer.borderColor = [UIColor lightGrayColor].CGColor;
    self.imageReview.layer.borderWidth = 5;
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

- (void)setData:(NSDictionary *)data {
    self.labelCustomer.text = (NSString *)[data objectForKey:@"customer_name"];
    self.imageRating.image = [UIImage imageNamed:[NSString stringWithFormat:@"rating%@", (NSString *)[data objectForKey:@"review_rating"]]];
    self.labelDate.text = [NSString stringWithFormat:@"on %@", (NSString *)[data objectForKey:@"review_date"]];
    NSError *error;
    NSMutableAttributedString *text = [[NSMutableAttributedString alloc] initWithData:[(NSString *)[data objectForKey:@"review_short"] dataUsingEncoding:NSUTF8StringEncoding] options:@{NSDocumentTypeDocumentAttribute: NSHTMLTextDocumentType, NSCharacterEncodingDocumentAttribute:[NSNumber numberWithInt:NSUTF8StringEncoding]} documentAttributes:nil error:&error];
    [text setAttributes:@{NSFontAttributeName: [UIFont systemFontOfSize:15]} range:NSMakeRange(0, text.length)];
    self.labelText.attributedText = text;
}

@end
