//
//  MoverReviewViewController.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 7/30/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "MoverReviewViewController.h"
#import "MoverSendMessageViewController.h"

@interface MoverReviewViewController ()

@property (weak, nonatomic) IBOutlet UILabel *labelTitle;
@property (weak, nonatomic) IBOutlet UIImageView *imageReview;
@property (weak, nonatomic) IBOutlet UILabel *labelCustomer;
@property (weak, nonatomic) IBOutlet UILabel *labelMover;
@property (weak, nonatomic) IBOutlet UIImageView *imageRating;
@property (weak, nonatomic) IBOutlet UILabel *labelDate;
@property (weak, nonatomic) IBOutlet UILabel *labelStates;
@property (weak, nonatomic) IBOutlet UILabel *labelText;
@property (weak, nonatomic) IBOutlet UILabel *labelPrice;
@property (weak, nonatomic) IBOutlet UIButton *buttonContact;

- (IBAction)onBack:(id)sender;

@end

@implementation MoverReviewViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.labelTitle.text = (NSString *)[self.review objectForKey:@"company_name"];
    self.labelCustomer.text = (NSString *)[self.review objectForKey:@"customer_name"];
    self.labelMover.text = (NSString *)[self.review objectForKey:@"review_title"];
    self.imageRating.image = [UIImage imageNamed:[NSString stringWithFormat:@"rating%@", (NSString *)[self.review objectForKey:@"review_rating"]]];
    self.labelDate.text = [NSString stringWithFormat:@"%@", (NSString *)[self.review objectForKey:@"review_date"]];
    NSError *error;
    NSMutableAttributedString *text = [[NSMutableAttributedString alloc] initWithData:[(NSString *)[self.review objectForKey:@"review_text"] dataUsingEncoding:NSUTF8StringEncoding] options:@{NSDocumentTypeDocumentAttribute: NSHTMLTextDocumentType, NSCharacterEncodingDocumentAttribute:[NSNumber numberWithInt:NSUTF8StringEncoding]} documentAttributes:nil error:&error];
    [text setAttributes:@{NSFontAttributeName: [UIFont systemFontOfSize:15]} range:NSMakeRange(0, text.length)];
    self.labelStates.text = [NSString stringWithFormat:@"Shipped from %@ to %@", [self.review objectForKey:@"pickup_state_full"], [self.review objectForKey:@"delivery_state_full"]];
    self.labelText.attributedText = text;
    self.labelPrice.text = [NSString stringWithFormat:@"%@ %@", [self.review objectForKey:@"review_price"], [self.review objectForKey:@"review_currency"]];
    NSString *email = (NSString *)[self.mover objectForKey:@"email"];
    if(email != nil && ![email isEqualToString:@""]) {
        [self.buttonContact setTitle:[NSString stringWithFormat:@"Contact %@", (NSString *)[self.review objectForKey:@"company_name"]] forState:UIControlStateNormal];
    }
    else {
        self.buttonContact.hidden = YES;
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
    if([segue.destinationViewController isKindOfClass:[MoverSendMessageViewController class]]) {
        ((MoverSendMessageViewController *)segue.destinationViewController).mover = self.mover;
    }
}


- (IBAction)onBack:(id)sender {
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

@end
