//
//  MoverSendMessageViewController.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 9/30/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "MoverSendMessageViewController.h"
#import "Utils.h"
#import "User.h"
#import "URLRequests.h"

@interface MoverSendMessageViewController ()

@property (weak, nonatomic) IBOutlet UIScrollView *scrollView;
@property (weak, nonatomic) IBOutlet UIView *viewContainer;
@property (weak, nonatomic) IBOutlet UIView *viewTable;

@property (weak, nonatomic) IBOutlet UILabel *labelTitle;
@property (weak, nonatomic) IBOutlet UIButton *buttonClose;

@property (weak, nonatomic) IBOutlet UIView *viewCompanySeparator;
@property (weak, nonatomic) IBOutlet UIImageView *imageCompany;
@property (weak, nonatomic) IBOutlet UILabel *labelCompany;
@property (weak, nonatomic) IBOutlet UIImageView *imageRating;
@property (weak, nonatomic) IBOutlet UILabel *labelRating;
@property (weak, nonatomic) IBOutlet UIView *viewCompanySeparatorBottom;

@property (weak, nonatomic) IBOutlet UIView *viewNameSeparator;
@property (weak, nonatomic) IBOutlet UILabel *labelNameHeader;
@property (weak, nonatomic) IBOutlet UILabel *labelNameError;
@property (weak, nonatomic) IBOutlet UITextField *textName;

@property (weak, nonatomic) IBOutlet UIView *viewEmailSeparator;
@property (weak, nonatomic) IBOutlet UILabel *labelEmailHeader;
@property (weak, nonatomic) IBOutlet UILabel *labelEmailError;
@property (weak, nonatomic) IBOutlet UITextField *textEmail;

@property (weak, nonatomic) IBOutlet UIView *viewPhoneSeparator;
@property (weak, nonatomic) IBOutlet UILabel *labelPhoneHeader;
@property (weak, nonatomic) IBOutlet UILabel *labelPhoneError;
@property (weak, nonatomic) IBOutlet UITextField *textPhone;

@property (weak, nonatomic) IBOutlet UIView *viewMessageSeparator;
@property (weak, nonatomic) IBOutlet UILabel *labelMessageHeader;
@property (weak, nonatomic) IBOutlet UILabel *labelMessageError;
@property (weak, nonatomic) IBOutlet UITextField *textMessage;

@property (weak, nonatomic) IBOutlet UIView *viewCheckBoxesSeparator;
@property (weak, nonatomic) IBOutlet UIButton *buttonAttachMyMoveInfo;
@property (weak, nonatomic) IBOutlet UIButton *buttonEmailMeACopy;
@property (weak, nonatomic) IBOutlet UIButton *buttonLetMoversEstimateMyMove;

@property (strong, nonatomic) NSString *name;
@property (strong, nonatomic) NSString *email;
@property (strong, nonatomic) NSString *phone;
@property (strong, nonatomic) NSString *message;

@property (weak, nonatomic) IBOutlet UIButton *buttonSendMessage;

@property (assign, nonatomic) CGRect rect;

- (IBAction)onBack:(id)sender;
- (IBAction)onCheckBoxClick:(id)sender;

@end

@implementation MoverSendMessageViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.buttonSendMessage.layer.cornerRadius = 5;
    [self setSeparatorShadow:self.viewCompanySeparator];
    [self setSeparatorShadow:self.viewCompanySeparatorBottom];
    [self setSeparatorShadow:self.viewNameSeparator];
    [self setSeparatorShadow:self.viewEmailSeparator];
    [self setSeparatorShadow:self.viewPhoneSeparator];
    [self setSeparatorShadow:self.viewMessageSeparator];
    [self setSeparatorShadow:self.viewCheckBoxesSeparator];
    self.labelTitle.text = [NSString stringWithFormat:@"Contact %@", (NSString *)[self.mover objectForKey:@"name"]];
    NSString *image = (NSString *)[self.mover objectForKey:@"logo_url"];
    self.imageCompany.image = [Utils loadImage:image download:^(UIImage *image) {
        self.imageCompany.image = image;
    }];
    self.labelCompany.text = (NSString *)[self.mover objectForKey:@"name"];
    self.imageRating.image = [UIImage imageNamed:[NSString stringWithFormat:@"rating%@", (NSString *)[self.mover objectForKey:@"rating"]]];
    self.labelRating.text = [NSString stringWithFormat:@"Based on %@ reviews", (NSString *)[self.mover objectForKey:@"total_reviews"]];
    User *user = [User getCurrent];
    self.textName.text = user.name;
    [self showLabel:self.labelNameHeader control:self.textName animated:NO];
    self.textEmail.text = user.email;
    [self showLabel:self.labelPhoneHeader control:self.textPhone animated:NO];
    self.textPhone.text = user.phone;
    [self showLabel:self.labelEmailHeader control:self.textEmail animated:NO];
    [Utils setText:self.buttonLetMoversEstimateMyMove text:@"mover_contact_screen-quote-checkbox"];
    [Utils setText:self.buttonSendMessage text:@"mover_contact_screen-button_submit"];
    self.buttonSendMessage.titleLabel.numberOfLines = 2;
    self.rect = CGRectZero;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)setSeparatorShadow:(UIView *)viewSeparator {
    viewSeparator.layer.shadowOffset = CGSizeMake(0, 5);
    viewSeparator.layer.shadowColor = [Utils getColor:COLOR_LIGHT_GRAY].CGColor;
    viewSeparator.layer.shadowRadius = 5;
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onShowKeyboard:) name:UIKeyboardWillShowNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onHideKeyboard:) name:UIKeyboardWillHideNotification object:nil];
}

- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIKeyboardWillShowNotification object:nil];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIKeyboardWillHideNotification object:nil];
}

- (void)setConstraints:(int)height duration:(float)duration {
    NSLayoutConstraint *constraintBottom = nil;
    NSLayoutConstraint *constraintHeight = nil;
    for(NSLayoutConstraint *constraint in self.scrollView.constraints) {
        if(constraint.secondAttribute == NSLayoutAttributeBottom && constraint.secondItem == self.viewContainer) {
            constraintBottom = constraint;
        }
    }
    for(NSLayoutConstraint *constraint in self.viewContainer.constraints) {
        if(constraint.firstAttribute == NSLayoutAttributeHeight) {
            constraintHeight = constraint;
        }
    }
    CGFloat bottom;
        bottom = height;
    if(duration > 0) {
        [self.scrollView layoutIfNeeded];
        [UIView animateWithDuration:duration animations:^{
            constraintBottom.constant = height;
            [self.scrollView layoutIfNeeded];
        }];
    }
    else {
        constraintBottom.constant = height;
    }
}

- (void)viewDidLayoutSubviews {
    [super viewDidLayoutSubviews];
    if(!CGRectEqualToRect(self.rect, self.view.frame)) {
        [self setConstraints:0 duration:0];
        self.rect = self.view.frame;
    }
}

- (void)onShowKeyboard:(NSNotification *)notification {
    CGRect rect = ((NSValue *)[notification.userInfo objectForKey:UIKeyboardFrameEndUserInfoKey]).CGRectValue;
    double duration = ((NSNumber *)[notification.userInfo objectForKey:UIKeyboardAnimationDurationUserInfoKey]).doubleValue;
    [self setConstraints:rect.size.height duration:duration];
}

- (void)onHideKeyboard:(NSNotification *)notification {
    double duration = ((NSNumber *)[notification.userInfo objectForKey:UIKeyboardAnimationDurationUserInfoKey]).doubleValue;
    [self setConstraints:0 duration:duration];
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (IBAction)onBack:(id)sender {
    if([self.textName isFirstResponder]) {
        [self.textName resignFirstResponder];
    }
    if([self.textEmail isFirstResponder]) {
        [self.textEmail resignFirstResponder];
    }
    if([self.textPhone isFirstResponder]) {
        [self.textPhone resignFirstResponder];
    }
    if([self.textMessage isFirstResponder]) {
        [self.textMessage resignFirstResponder];
    }
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

- (IBAction)onCheckBoxClick:(id)sender {
    UIButton *button = (UIButton *)sender;
    button.selected = !button.selected;
}

- (void)showLabel:(UILabel *)label control:(UIControl *)control animated:(BOOL)animated {
    if(animated) {
        CATransition *transition = [[CATransition alloc] init];
        transition.type = kCATransitionFade;
        transition.subtype = kCATransitionFromBottom;
        transition.duration = 0.25;
        [label.layer addAnimation:transition forKey:kCATransition];
    }
    label.hidden = NO;
    if([control isKindOfClass:[UIButton class]]) {
        [(UIButton *)control setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    }
    for(NSLayoutConstraint *constraint in control.superview.constraints) {
        if(constraint.firstAttribute == NSLayoutAttributeTop && constraint.firstItem == control) {
            constraint.constant = 30;
        }
    }
}

- (void)hideLabel:(UILabel *)label control:(UIControl *)control animated:(BOOL)animated {
    if(animated) {
        CATransition *transition = [[CATransition alloc] init];
        transition.type = kCATransitionFade;
        transition.subtype = kCATransitionFromBottom;
        transition.duration = 0.25;
        [label.layer addAnimation:transition forKey:kCATransition];
    }
    label.hidden = YES;
    if([control isKindOfClass:[UIButton class]]) {
        [(UIButton *)control setTitleColor:[UIColor colorWithWhite:0.785f alpha:1] forState:UIControlStateNormal];
    }
    for(NSLayoutConstraint *constraint in control.superview.constraints) {
        if(constraint.firstAttribute == NSLayoutAttributeTop && constraint.firstItem == control) {
            constraint.constant = 5;
        }
    }
}

- (BOOL)check:(BOOL)valid label:(UILabel *)label {
    CATransition *transition = [[CATransition alloc] init];
    transition.type = kCATransitionFade;
    transition.subtype = kCATransitionFromBottom;
    transition.duration = 0.25;
    [label.layer addAnimation:transition forKey:kCATransition];
    if(valid) {
        label.hidden = YES;
        return YES;
    }
    else {
        label.hidden = NO;
        return NO;
    }
}

- (IBAction)onOK:(id)sender {
    BOOL checkName = [self check:[Utils validateName:self.textName.text] label:self.labelNameError];
    BOOL checkEmail = [self check:[Utils validateEmail:self.textEmail.text] label:self.labelEmailError];
    BOOL checkPhone = [self check:[Utils validatePhone:self.textPhone.text] label:self.labelPhoneError];
    //BOOL checkMessage = [self check:![self.textMessage.text isEqualToString:@""] label:self.labelMessageError];
    if(checkName && checkPhone && checkEmail /*&& checkMessage*/) {
        User *user = [User getCurrent];
        user.name = self.textName.text;
        user.email = self.textEmail.text;
        user.phone = self.textPhone.text;
        [user save];
        if([self.textName isFirstResponder]) {
            [self.textName resignFirstResponder];
        }
        if([self.textEmail isFirstResponder]) {
            [self.textEmail resignFirstResponder];
        }
        if([self.textPhone isFirstResponder]) {
            [self.textPhone resignFirstResponder];
        }
        if([self.textMessage isFirstResponder]) {
            [self.textMessage resignFirstResponder];
        }
        NSMutableArray<NSString *> *emails = [[NSMutableArray<NSString *> alloc] init];
        [emails addObject:[self.mover objectForKey:@"email"]];
        if(self.buttonEmailMeACopy.selected) {
            [emails addObject:user.email];
        }
        UIViewController *controller = [[UIViewController alloc] init];
        controller.modalPresentationStyle = UIModalPresentationOverFullScreen;
        controller.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
        UIView *view = [[UIView alloc] init];
        view.backgroundColor = [Utils getColor:0x80000000];
        controller.view = view;
        UIActivityIndicatorView *progress = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
        progress.color = [Utils getColor:COLOR_GREEN];
        progress.translatesAutoresizingMaskIntoConstraints = NO;
        [progress startAnimating];
        [view addSubview:progress];
        [view addConstraint:[NSLayoutConstraint constraintWithItem:progress attribute:NSLayoutAttributeCenterX relatedBy:NSLayoutRelationEqual toItem:view attribute:NSLayoutAttributeCenterX multiplier:1 constant:0]];
        [view addConstraint:[NSLayoutConstraint constraintWithItem:progress attribute:NSLayoutAttributeCenterY relatedBy:NSLayoutRelationEqual toItem:view attribute:NSLayoutAttributeCenterY multiplier:1 constant:0]];
        [self presentViewController:controller animated:YES completion:^{
            [URLRequests sendQuoteEmail:self.textMessage.text emails:emails inventory:self.buttonAttachMyMoveInfo.selected receive:^(BOOL success, NSString *error){
                if(success) {
                    if(self.buttonLetMoversEstimateMyMove.selected) {
                        [URLRequests sendQuote:^(BOOL success, NSString *error){
                            [self dismissViewControllerAnimated:YES completion:^{
                                if(success) {
                                    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Email successfully sent" message:@"Great! Your email(s) were successfully sent!" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
                                    [alert show];
                                }
                                else {
                                    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Failed to send quote!" message:error delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
                                    [alert show];
                                }
                            }];
                        }];
                    }
                    else {
                        [self dismissViewControllerAnimated:YES completion:^{
                            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Email successfully sent" message:@"Great! Your email(s) were successfully sent!" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
                            [alert show];
                        }];
                    }
                }
                else {
                    [self dismissViewControllerAnimated:YES completion:^{
                        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Failed to send email!" message:error delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
                        [alert show];
                    }];
                }
            }];
        }];
    }
}

#pragma mark - UIAlertViewDelegate

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
    [self.presentingViewController dismissViewControllerAnimated:YES completion:^{

    }];
}

#pragma mark - UITextFieldDelegate

- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
    NSString *text = [textField.text stringByReplacingCharactersInRange:range withString:string];
    if(textField == self.textName) {
        if(![text isEqualToString:@""]) {
            [self showLabel:self.labelNameHeader control:self.textName animated:YES];
        }
        else {
            [self hideLabel:self.labelNameHeader control:self.textName animated:YES];
        }
        [self check:YES label:self.labelNameError];
    }
    else if(textField == self.textEmail) {
        if(![text isEqualToString:@""]) {
            [self showLabel:self.labelEmailHeader control:self.textEmail animated:YES];
        }
        else {
            [self hideLabel:self.labelEmailHeader control:self.textEmail animated:YES];
        }
        [self check:YES label:self.labelEmailError];
    }
    else if(textField == self.textPhone) {
        if(![text isEqualToString:@""]) {
            [self showLabel:self.labelPhoneHeader control:self.textPhone animated:YES];
        }
        else {
            [self hideLabel:self.labelPhoneHeader control:self.textPhone animated:YES];
        }
        [self check:YES label:self.labelPhoneError];
    }
    else if(textField == self.textMessage) {
        if(![text isEqualToString:@""]) {
            [self showLabel:self.labelMessageHeader control:self.textMessage animated:YES];
        }
        else {
            [self hideLabel:self.labelMessageHeader control:self.textMessage animated:YES];
        }
        [self check:YES label:self.labelMessageError];
    }
    return YES;
}

- (void)textFieldDidBeginEditing:(UITextField *)textField {
}

- (void)textFieldDidEndEditing:(UITextField *)textField {
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
    [textField resignFirstResponder];
    return YES;
}

@end
