//
//  MoverTableViewCell.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 7/4/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "MoverTableViewCell.h"
#import "Utils.h"

@interface MoverTableViewCell ()

@property (weak, nonatomic) IBOutlet UIImageView *imageCompany;
@property (weak, nonatomic) IBOutlet UILabel *labelCompany;
@property (weak, nonatomic) IBOutlet UIImageView *imageRating;
@property (weak, nonatomic) IBOutlet UILabel *labelRating;

@end

@implementation MoverTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

- (void)setData:(NSDictionary *)data reviews:(NSUInteger)reviews {
    NSString *image = (NSString *)[data objectForKey:@"logo_url"];
    if(image != nil && ![image isEqualToString:@""]) {
        self.imageCompany.image = [Utils loadImage:image download:^(UIImage *image) {
            self.imageCompany.image = image;
        }];
        self.imageCompany.backgroundColor = [UIColor clearColor];
    }
    else {
        self.imageCompany.image = [UIImage imageNamed:@"no_logo"];
        self.imageCompany.backgroundColor = [Utils getColor:0xFFFAFAFA];
    }
    self.labelCompany.text = (NSString *)[data objectForKey:@"name"];
    self.imageRating.image = [UIImage imageNamed:[NSString stringWithFormat:@"rating%@", (NSString *)[data objectForKey:@"rating"]]];
    self.labelRating.text = [NSString stringWithFormat:@"Based on %lu reviews", (unsigned long)reviews];
}

@end
