//
//  MoverViewController.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 7/4/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "MoverViewController.h"
#import "MoverTableViewCell.h"
#import "MoverContactTableViewCell.h"
#import "MoverInfoTableViewCell.h"
#import "MoverReviewTableViewCell.h"
#import "MoverReviewViewController.h"
#import "MoverContactViewController.h"
#import "MoverSendMessageViewController.h"
#import "Utils.h"

@interface MoverViewController ()

@property (weak, nonatomic) IBOutlet UILabel *labelMover;
@property (weak, nonatomic) IBOutlet UITableView *tableMover;

@property (strong, nonatomic) NSMutableArray<NSDictionary<NSString *, NSString *> *> *contacts;
@property (strong, nonatomic) NSMutableDictionary *mover;
@property (strong, nonatomic) NSArray *reviews;

@property (assign, nonatomic) BOOL contact;

@end

@implementation MoverViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.labelMover.text = self.movername;
    self.contacts = [[NSMutableArray<NSDictionary<NSString *, NSString *> *> alloc] init];
    UIViewController *controller = [[UIViewController alloc] init];
    controller.modalPresentationStyle = UIModalPresentationOverFullScreen;
    controller.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
    UIView *view = [[UIView alloc] init];
    view.backgroundColor = [Utils getColor:0x80000000];
    controller.view = view;
    UIActivityIndicatorView *progress = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    progress.color = [Utils getColor:COLOR_GREEN];
    progress.translatesAutoresizingMaskIntoConstraints = NO;
    [progress startAnimating];
    [view addSubview:progress];
    [view addConstraint:[NSLayoutConstraint constraintWithItem:progress attribute:NSLayoutAttributeCenterX relatedBy:NSLayoutRelationEqual toItem:view attribute:NSLayoutAttributeCenterX multiplier:1 constant:0]];
    [view addConstraint:[NSLayoutConstraint constraintWithItem:progress attribute:NSLayoutAttributeCenterY relatedBy:NSLayoutRelationEqual toItem:view attribute:NSLayoutAttributeCenterY multiplier:1 constant:0]];
    [self addChildViewController:controller];
    [self.view addSubview:controller.view];
    view.translatesAutoresizingMaskIntoConstraints = NO;
    [self.view addConstraint:[NSLayoutConstraint constraintWithItem:view attribute:NSLayoutAttributeLeading relatedBy:NSLayoutRelationEqual toItem:self.view attribute:NSLayoutAttributeLeading multiplier:1 constant:0]];
    [self.view addConstraint:[NSLayoutConstraint constraintWithItem:view attribute:NSLayoutAttributeTrailing relatedBy:NSLayoutRelationEqual toItem:self.view attribute:NSLayoutAttributeTrailing multiplier:1 constant:0]];
    [self.view addConstraint:[NSLayoutConstraint constraintWithItem:view attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self.view attribute:NSLayoutAttributeTop multiplier:1 constant:0]];
    [self.view addConstraint:[NSLayoutConstraint constraintWithItem:view attribute:NSLayoutAttributeBottom relatedBy:NSLayoutRelationEqual toItem:self.view attribute:NSLayoutAttributeBottom multiplier:1 constant:0]];
    NSURLSessionConfiguration *configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession *session = [NSURLSession sessionWithConfiguration:configuration delegate:nil delegateQueue:[NSOperationQueue mainQueue]];
    NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:[NSString stringWithFormat:@"https://www.mymovingreviews.com/iphoneapprequest.php?get=companyinfo&companyID=%@&output=json&ctype=car-moving", self.moverid]]];
    NSURLSessionDataTask *task = [session dataTaskWithRequest:request completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
        if(data != nil) {
            NSError *jsonerror;
            NSDictionary *jsonobject = (NSDictionary *)[NSJSONSerialization JSONObjectWithData:data options:0 error:&jsonerror];
            NSDictionary *obj = (NSDictionary *)[jsonobject objectForKey:@"company"];
            self.mover = [[NSMutableDictionary alloc] init];
            [self.mover setObject:[obj objectForKey:@"logo_url"] forKey:@"logo_url"];
            [self.mover setObject:[obj objectForKey:@"name"] forKey:@"name"];
            [self.mover setObject:[[NSMutableArray<NSDictionary<NSString *, NSString *> *> alloc] init] forKey:@"numbers"];
            self.labelMover.text = (NSString *)[self.mover objectForKey:@"name"];
            [self addContact:obj key:@"freephone" type:@"phone" image:@"free_phone"];
            [self addContact:obj key:@"phones" type:@"phone" image:@"phone"];
            [self addContact:obj key:@"email" type:@"email" image:@"email"];
            [self addContact:obj key:@"website/link" type:@"website" image:@"website"];
            NSString *email = (NSString *)[obj objectForKey:@"email"];
            if(email != nil && ![email isEqualToString:@""]) {
                [self.mover setObject:email forKey:@"email"];
                self.contact = YES;
            }
            NSMutableString *info = [[NSMutableString alloc] init];
            [self addInfo:obj key:@"addinfo" info:info];
            [self addInfo:obj key:@"info" info:info];
            if(info != nil) {
                NSError *error;
                NSMutableAttributedString *text = [[NSMutableAttributedString alloc] initWithData:[info dataUsingEncoding:NSUTF8StringEncoding] options:@{NSDocumentTypeDocumentAttribute: NSHTMLTextDocumentType, NSCharacterEncodingDocumentAttribute:[NSNumber numberWithInt:NSUTF8StringEncoding]} documentAttributes:nil error:&error];
                [text setAttributes:@{NSFontAttributeName: [UIFont systemFontOfSize:17]} range:NSMakeRange(0, text.length)];
                [self.mover setObject:text forKey:@"info"];
            }
            [self addNumber:obj key:@"us_dot_num" image:@"icon_us_lic"];
            [self addNumber:obj key:@"mc_lic_num" image:@"icon_mc_lic"];
            [self addNumber:obj key:@"local_lic_num" image:@"icon_local_lic"];
            NSArray *statesoper = (NSArray *)[obj objectForKey:@"states_oper"];
            if(statesoper != nil && statesoper.count > 0) {
                NSMutableArray<NSDictionary<NSString *, NSString *> *> *numbers = (NSMutableArray<NSDictionary<NSString *, NSString *> *> *)[self.mover objectForKey:@"numbers"];
                [numbers addObject:@{@"text": @"Moving Interstate", @"image": @"icon_interstate"}];
            }
            [self.mover setObject:[obj objectForKey:@"rating"] forKey:@"rating"];
            self.reviews = (NSArray *)[jsonobject objectForKey:@"reviews"];
            [self.mover setObject:[NSNumber numberWithLong:self.reviews.count] forKey:@"total_reviews"];
            int ratings1 = 0;
            int ratings2 = 0;
            int ratings3 = 0;
            int ratings4 = 0;
            int ratings5 = 0;
            for(NSDictionary *review in self.reviews) {
                NSString *rating = (NSString *)[review objectForKey:@"review_rating"];
                if(rating != nil && ![rating isEqualToString:@""]) {
                    switch(rating.intValue) {
                        case 1:
                            ratings1++;
                            break;
                        case 2:
                            ratings2++;
                            break;
                        case 3:
                            ratings3++;
                            break;
                        case 4:
                            ratings4++;
                            break;
                        case 5:
                            ratings5++;
                            break;
                    }
                }
            }
            [self.mover setObject:@[
                                    @{@"type": @"Excellent", @"reviews": [NSNumber numberWithInt:ratings5]},
                                    @{@"type": @"Good", @"reviews": [NSNumber numberWithInt:ratings4]},
                                    @{@"type": @"Average", @"reviews": [NSNumber numberWithInt:ratings3]},
                                    @{@"type": @"Unsatisfactory", @"reviews": [NSNumber numberWithInt:ratings2]},
                                    @{@"type": @"Poor", @"reviews": [NSNumber numberWithInt:ratings1]}
                                    ]
                           forKey:@"ratings"];
            [self.tableMover reloadData];
            self.tableMover.hidden = NO;
            [controller.view removeFromSuperview];
            [controller removeFromParentViewController];
        }
    }];
    [task resume];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
    if([segue.destinationViewController isKindOfClass:[MoverReviewViewController class]]) {
        ((MoverReviewViewController *)segue.destinationViewController).mover = self.mover;
        ((MoverReviewViewController *)segue.destinationViewController).review = (NSDictionary *)[self.reviews objectAtIndex:[self.tableMover indexPathForCell:(MoverReviewTableViewCell *)((UIButton *)sender).superview.superview].row - self.contacts.count - 3 - (self.contact ? 1 : 0)];
    }
    else if([segue.destinationViewController isKindOfClass:[MoverContactViewController class]]) {
        MoverContactViewController *controller = (MoverContactViewController *)segue.destinationViewController;
        controller.textTitle = [NSString stringWithFormat:@"Contact %@", (NSString *)[self.mover objectForKey:@"name"]];
        NSIndexPath *path = [self.tableMover indexPathForCell:(UITableViewCell *)sender];
        if(path != nil) {
            controller.contact = [self.contacts objectAtIndex:path.row - 1];
            controller.mover = self.mover;
        }
    }
    else if([segue.destinationViewController isKindOfClass:[MoverSendMessageViewController class]]) {
        ((MoverSendMessageViewController *)segue.destinationViewController).mover = self.mover;
    }
}


- (void)addContact:(NSDictionary *)obj key:(NSString *)key type:(NSString *)type image:(NSString *)image {
    NSArray<NSString *> *components = [key componentsSeparatedByString:@"/"];
    for(int i=0; i<components.count - 1 && obj != nil; i++) {
        obj = [obj objectForKey:[components objectAtIndex:i]];
    }
    if(obj != nil) {
        NSString *contact = (NSString *)[obj objectForKey:[components objectAtIndex:components.count - 1]];
        if(contact != nil && ![contact isEqualToString:@""]) {
            [self.contacts addObject:@{@"type": type, @"image": image, @"contact": contact}];
        }
    }
}

- (void)addInfo:(NSDictionary *)obj key:(NSString *)key info:(NSMutableString *)info {
    id text = [obj objectForKey:key];
    if(text != nil && [text isKindOfClass:[NSString class]] && ![text isEqualToString:@""]) {
        if(info.length > 0) {
            [info appendString:@"\n"];
        }
        [info appendString:(NSString *)text];
    }
}

- (void)addNumber:(NSDictionary *)obj key:(NSString *)key image:(NSString *)image {
    id text = [obj objectForKey:key];
    if(text != nil && [text isKindOfClass:[NSString class]] && ![text isEqualToString:@""]) {
        NSMutableArray<NSDictionary<NSString *, NSString *> *> *numbers = (NSMutableArray<NSDictionary<NSString *, NSString *> *> *)[self.mover objectForKey:@"numbers"];
        [numbers addObject:@{@"text": (NSString *)text, @"image": image}];
    }
}

- (IBAction)onBack:(id)sender {
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

#pragma mark - UITableViewDataSource

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.reviews.count + self.contacts.count + 4 + (self.contact ? 1 : 0);
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    if(indexPath.row == 0) {
        MoverTableViewCell *cell = (MoverTableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"mover"];
        [cell setData:self.mover reviews:self.reviews.count];
        return cell;
    }
    else if(indexPath.row <= self.contacts.count) {
        MoverContactTableViewCell *cell = (MoverContactTableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"contact"];
        NSDictionary<NSString *, NSString *> *contact = [self.contacts objectAtIndex:indexPath.row - 1];
        [cell setImage:[contact objectForKey:@"image"] text:[contact objectForKey:@"contact"]];
        if(indexPath.row - 1 < self.contacts.count - 1) {
            cell.selectionStyle = UITableViewCellSelectionStyleDefault;
        }
        else {
            cell.selectionStyle = UITableViewCellSelectionStyleNone;
        }
        return cell;
    }
    else if(indexPath.row == self.contacts.count + 1 && self.contact) {
        MoverContactTableViewCell *cell = (MoverContactTableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"message"];
        NSString *text = [Utils getText:@"mover_profile_screen-button_contact"];
        if(text == nil) {
            text = @"Contact this shipper";
        }
        [cell setImage:@"contact_mover" text:text];
        return cell;
    }
    else if(indexPath.row == self.contacts.count + 1 + (self.contact ? 1 : 0)) {
        UITableViewCell *cell = (UITableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"quote"];
        return cell;
    }
    else if(indexPath.row == self.contacts.count + 2 + (self.contact ? 1 : 0)) {
        MoverInfoTableViewCell *cell = (MoverInfoTableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"info"];
        [cell setData:self.mover reviews:self.reviews.count];
        return cell;
    }
    else if(indexPath.row <= self.contacts.count + self.reviews.count + 2 + (self.contact ? 1 : 0)) {
        MoverReviewTableViewCell *cell = (MoverReviewTableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"review"];
        NSDictionary *review = (NSDictionary *)[self.reviews objectAtIndex:indexPath.row - self.contacts.count - 3 - (self.contact ? 1 : 0)];
        [cell setData:review];
        return cell;
    }
    else if(indexPath.row == self.contacts.count + self.reviews.count + 3 + (self.contact ? 1 : 0)) {
        UITableViewCell *cell = (UITableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"quote"];
        return cell;
    }
    else {
        return nil;
    }
}

#pragma mark - UITableViewDelegate

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    if(indexPath.row == 0) {
        return 96;
    }
    else if(indexPath.row <= self.contacts.count +  + (self.contact ? 1 : 0)) {
        return 44;
    }
    else if(indexPath.row == self.contacts.count + 1 + (self.contact ? 1 : 0)) {
        return 70;
    }
    else if(indexPath.row == self.contacts.count + 2 + (self.contact ? 1 : 0)) {
        NSAttributedString *text = (NSAttributedString *)[self.mover objectForKey:@"info"];
        if(text != nil) {
            CGRect rect = [text boundingRectWithSize:CGSizeMake(tableView.frame.size.width - 20, CGFLOAT_MAX) options:NSStringDrawingUsesLineFragmentOrigin context:nil];
            return rect.size.height + 350;
        }
        else {
            return 330;
        }
    }
    else if(indexPath.row <= self.contacts.count + self.reviews.count + 2 + (self.contact ? 1 : 0)) {
        NSDictionary *review = (NSDictionary *)[self.reviews objectAtIndex:indexPath.row - self.contacts.count - 3 - (self.contact ? 1 : 0)];
        NSError *error;
        NSMutableAttributedString *text = [[NSMutableAttributedString alloc] initWithData:[(NSString *)[review objectForKey:@"review_short"] dataUsingEncoding:NSUTF8StringEncoding] options:@{NSDocumentTypeDocumentAttribute: NSHTMLTextDocumentType, NSCharacterEncodingDocumentAttribute:[NSNumber numberWithInt:NSUTF8StringEncoding]} documentAttributes:nil error:&error];
        [text setAttributes:@{NSFontAttributeName: [UIFont systemFontOfSize:15]} range:NSMakeRange(0, text.length)];
        CGRect rect = [text boundingRectWithSize:CGSizeMake(tableView.frame.size.width - 10, 110) options:NSStringDrawingUsesLineFragmentOrigin context:nil];
        return rect.size.height + 130;
    }
    else if(indexPath.row == self.contacts.count + self.reviews.count + 3 + (self.contact ? 1 : 0)) {
        return 70;
    }
    else {
        return 44;
    }
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    if(indexPath.row >= 1 && indexPath.row <= self.contacts.count) {
        if(self.contact) {
            [self performSegueWithIdentifier:@"contact" sender:[tableView cellForRowAtIndexPath:indexPath]];
        }
        else {
            NSString *type = [[self.contacts objectAtIndex:indexPath.row - 1] objectForKey:@"type"];
            NSString *contact = [[self.contacts objectAtIndex:indexPath.row - 1] objectForKey:@"contact"];
            NSString *url = nil;
            if([type isEqualToString:@"phone"]) {
                url = [NSString stringWithFormat:@"tel://%@", [[[[contact stringByReplacingOccurrencesOfString:@" " withString:@""] stringByReplacingOccurrencesOfString:@"-" withString:@""] stringByReplacingOccurrencesOfString:@"(" withString:@""] stringByReplacingOccurrencesOfString:@")" withString:@""]];
            }
            else if([type isEqualToString:@"email"]) {
                url = [NSString stringWithFormat:@"mailto:?to=%@", contact];
            }
            else if([type isEqualToString:@"website"]) {
                url = contact;
            }
            if(url != nil) {
                [[UIApplication sharedApplication] openURL:[NSURL URLWithString:url]];
            }
        }
    }
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
}

@end
