//
//  QuoteCollectionViewCell.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 9/30/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "QuoteCollectionViewCell.h"
#import "User.h"

@interface QuoteCollectionViewCell ()

@property (weak, nonatomic) IBOutlet UIImageView *imageView;
@property (weak, nonatomic) IBOutlet UIView *viewDate;
@property (weak, nonatomic) IBOutlet UILabel *labelMonth;
@property (weak, nonatomic) IBOutlet UILabel *labelDay;
@property (weak, nonatomic) IBOutlet UILabel *labelText;

@end

@implementation QuoteCollectionViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    self.viewDate.layer.borderColor = [UIColor lightGrayColor].CGColor;
    self.viewDate.layer.borderWidth = 1;
}

- (void)setText:(NSString *)text image:(NSString *)image {
    self.imageView.image = [UIImage imageNamed:image];
    self.labelText.text = text;
    self.labelMonth.text = @"";
    self.labelDay.text = @"";
    self.imageView.hidden = NO;
    self.labelMonth.hidden = YES;
    self.labelDay.hidden = YES;
}

- (void)setText:(NSString *)text month:(NSString *)month day:(NSString *)day {
    self.imageView.image = nil;
    self.labelText.text = text;
    self.labelMonth.text = month;
    self.labelDay.text = day;
    self.imageView.hidden = YES;
    self.labelMonth.hidden = NO;
    self.labelDay.hidden = NO;
}

@end
