//
//  RatingViewController.m
//  MoveAdvisor
//
//  Created by Outsourcing It Services Ltd on 3/7/17.
//  Copyright © 2017 Outsourcing IT Services Ltd. All rights reserved.
//

#import "RatingViewController.h"
#import "RatingLowerViewController.h"
#import "User.h"

@interface RatingViewController ()

@property (weak, nonatomic) IBOutlet UIView *viewContainer;

@property (weak, nonatomic) IBOutlet UIButton *buttonRating1;
@property (weak, nonatomic) IBOutlet UIButton *buttonRating2;
@property (weak, nonatomic) IBOutlet UIButton *buttonRating3;
@property (weak, nonatomic) IBOutlet UIButton *buttonRating4;
@property (weak, nonatomic) IBOutlet UIButton *buttonRating5;

@property (assign, nonatomic) int rating;

- (IBAction)onRatingTouchDown:(id)sender;
- (IBAction)onRatingTouchDragEnter:(id)sender;
- (IBAction)onRatingTouchDragExit:(id)sender;
- (IBAction)onRatingTouchUpOutside:(id)sender;
- (IBAction)onRatingTouchUpInside:(id)sender;
- (IBAction)onClose:(id)sender;

@end

@implementation RatingViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.viewContainer.layer.cornerRadius = 5;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
    if([segue.destinationViewController isKindOfClass:[RatingLowerViewController class]]) {
        int rating = 0;
        if(sender == self.buttonRating1) {
            rating = 1;
        }
        else if(sender == self.buttonRating2) {
            rating = 2;
        }
        else if(sender == self.buttonRating3) {
            rating = 3;
        }
        else if(sender == self.buttonRating4) {
            rating = 4;
        }
        ((RatingLowerViewController *)segue.destinationViewController).rating = rating;
    }
}


- (IBAction)onRatingTouchDown:(id)sender {
    //int rating = 0;
    if(sender == self.buttonRating1) {
        self.rating = 1;
    }
    else if(sender == self.buttonRating2) {
        self.rating = 2;
    }
    else if(sender == self.buttonRating3) {
        self.rating = 3;
    }
    else if(sender == self.buttonRating4) {
        self.rating = 4;
    }
    else if(sender == self.buttonRating5) {
        self.rating = 5;
    }
    self.buttonRating1.selected = self.rating > 1;
    self.buttonRating2.selected = self.rating > 2;
    self.buttonRating3.selected = self.rating > 3;
    self.buttonRating4.selected = self.rating > 4;
    self.buttonRating5.selected = self.rating > 5;
}

- (IBAction)onRatingTouchDragEnter:(id)sender {
    self.buttonRating1.selected = self.rating > 1;
    self.buttonRating2.selected = self.rating > 2;
    self.buttonRating3.selected = self.rating > 3;
    self.buttonRating4.selected = self.rating > 4;
    self.buttonRating5.selected = self.rating > 5;
}

- (IBAction)onRatingTouchDragExit:(id)sender {
    self.buttonRating1.selected = NO;
    self.buttonRating2.selected = NO;
    self.buttonRating3.selected = NO;
    self.buttonRating4.selected = NO;
    self.buttonRating5.selected = NO;
}

- (IBAction)onRatingTouchUpOutside:(id)sender {
    self.buttonRating1.selected = NO;
    self.buttonRating2.selected = NO;
    self.buttonRating3.selected = NO;
    self.buttonRating4.selected = NO;
    self.buttonRating5.selected = NO;
    self.rating = 0;
}

- (IBAction)onRatingTouchUpInside:(id)sender {
    if(sender == self.buttonRating5) {
        [self performSegueWithIdentifier:@"maximum" sender:sender];
    }
    else {
        [self performSegueWithIdentifier:@"lower" sender:sender];
    }
}

- (IBAction)onClose:(id)sender {
    User *user = [User getCurrent];
    user.launchcount = 0;
    user.launchdate = [NSDate date];
    [user save];
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

@end
