//
//  RideListViewController.m
//  RideShipper
//
//  Created by Outsourcing IT Services Ltd. on 11/11/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "RideListViewController.h"
#import "RideListTableViewCell.h"
#import "URLRequests.h"

@interface RideListViewController ()

@property (weak, nonatomic) IBOutlet UIView *viewContainer;

@property (weak, nonatomic) IBOutlet UILabel *labelTitle;

@property (weak, nonatomic) IBOutlet UITableView *tableList;

- (IBAction)onBack:(id)sender;

@end

@implementation RideListViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.viewContainer.layer.cornerRadius = 5;
    self.labelTitle.text = [NSString stringWithFormat:@"Select %@", self.type];
    if([self.list isEqualToString:@"makes"]) {
//        [URLRequests getMakes:^(NSArray *makes) {
//            self.values = makes;
//            [self.tableList reloadData];
//        }];
    }
    else if([self.list isEqualToString:@"models"]) {
        [URLRequests getModels:(NSString *)[self.filter objectForKey:@"make_name"] receive:^(NSArray *models) {
            self.values = models;
            [self.tableList reloadData];
        }];
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */

- (IBAction)onBack:(id)sender {
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

#pragma mark - UITableViewDataSource

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.values.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    RideListTableViewCell *cell = (RideListTableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"cell"];
    NSDictionary *value = [self.values objectAtIndex:indexPath.row];
    if([self.list isEqualToString:@"makes"]) {
        [cell setText:(NSString *)[value objectForKey:@"make_name"]];
    }
    else if([self.list isEqualToString:@"models"]) {
        [cell setText:(NSString *)[value objectForKey:@"model_name"]];
    }
    return cell;
}

#pragma mark - UITableViewDelegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    NSDictionary *value = [self.values objectAtIndex:indexPath.row];
    if(self.close != nil) {
        self.close(value);
    }
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

@end
