//
//  StatesViewController.m
//  MoveAdvisor
//
//  Created by Outsourcing IT Services Ltd. on 8/11/16.
//  Copyright © 2016 Outsourcing IT Services Ltd. All rights reserved.
//

#import "StatesViewController.h"
#import "StatesTableViewCell.h"

@interface StatesViewController ()

@property (weak, nonatomic) IBOutlet UIView *viewContainer;

@property (weak, nonatomic) IBOutlet UITableView *tableStates;

@property (strong, nonatomic) NSMutableArray<NSDictionary *> *states;

- (IBAction)onBack:(id)sender;

@end

@implementation StatesViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.viewContainer.layer.cornerRadius = 5;
    NSString *path = [[NSBundle mainBundle] pathForResource:@"states" ofType:@"json"];
    NSData *data = [NSData dataWithContentsOfFile:path];
    if(data != nil) {
        NSError *jsonerror;
        NSDictionary<NSString *, NSDictionary *> *json = (NSDictionary<NSString *, NSDictionary *> *)[NSJSONSerialization JSONObjectWithData:data options:0 error:&jsonerror];
        if(json != nil) {
            self.states = [[NSMutableArray<NSDictionary *> alloc] init];
            for(NSString *key in json.allKeys) {
                [self.states addObject:@{@"id": [NSNumber numberWithInt:((NSString *)[[json objectForKey:key] objectForKey:@"id"]).intValue], @"abr": [[json objectForKey:key] objectForKey:@"abr"], @"name": [[json objectForKey:key] objectForKey:@"name"]}];
            }
            [self.states sortUsingComparator:^NSComparisonResult(id obj1, id obj2) {
                NSString *abr1 = (NSString *)(NSDictionary *)[obj1 objectForKey:@"abr"];
                NSString *abr2 = (NSString *)(NSDictionary *)[obj2 objectForKey:@"abr"];
                return [abr1 compare:abr2];
            }];
            [self.tableStates reloadData];
            if(self.state != nil) {
                NSString *state = (NSString *)[self.state objectForKey:@"abr"];
                for(int i=0; i<self.states.count; i++) {
                    if([(NSString *)[[self.states objectAtIndex:i] objectForKey:@"abr"] isEqualToString:state]) {
                        [self.tableStates selectRowAtIndexPath:[NSIndexPath indexPathForRow:i inSection:0] animated:NO scrollPosition:UITableViewScrollPositionTop];
                        break;
                    }
                }
            }
        }
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (IBAction)onBack:(id)sender {
    [self dismissViewControllerAnimated:YES completion:^{
        
    }];
}

#pragma mark - UITableViewDataSource

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.states.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    StatesTableViewCell *cell = (StatesTableViewCell *)[tableView dequeueReusableCellWithIdentifier:@"cell"];
    NSDictionary *state = [self.states objectAtIndex:indexPath.row];
    [cell setData:state];
    return cell;
}

#pragma mark - UITableViewDelegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    NSDictionary *state = [self.states objectAtIndex:indexPath.row];
    if(self.close != nil) {
        self.close(state);
    }
    [self dismissViewControllerAnimated:YES completion:^{

    }];
}

@end
